;    Copyright (C) 2011  Sergio Oller <sergioller@gmail.com>
;
;    This script is free software; you can redistribute it and/or
;    modify it under the terms of the GNU Lesser General Public
;    License as published by the Free Software Foundation; either
;    version 2.1 of the License, or (at your option) any later version.
;
;    This library is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;    Lesser General Public License for more details.
;
;    You should have received a copy of the GNU Lesser General Public
;    License along with this library; if not, write to the Free Software
;    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

(defvar hts_synth_pre_hooks nil)
(defvar SaveLabel_fp t )

(defSynthType HTSLABEL
 (apply_hooks hts_synth_pre_hooks utt)
 (hts_dump_feats_from_fp utt hts_feats_list SaveLabel_fp)
 utt
)

(define (hts_dump_feats_from_fp utt feats ofile)
    (mapcar
     (lambda (s)
       (hts_feats_output ofile s))
     (utt.relation.items utt 'Segment)
    )
)

(define (SaveLabel text filename)
"(SaveLabel TEXT FILENAME)
TEXT, a string. Label generated"
   (set! SaveLabel_fp (fopen filename "w"))
   (Param.set 'Synth_Method "HTSLABEL")
   (utt.synth (eval (list 'Utterance 'Text text)))
   (fclose SaveLabel_fp)
 filename
)
